searchNodes=[{"doc":"Documentation for Shogun .","ref":"Shogun.html","title":"Shogun","type":"module"},{"doc":"Wrapper that uses gun websocket client Usage defmodule MyWebsocket do use Shogun.Websocket end { :ok , pid } = MyWebsocket . start_link ( url : &quot;ws://localhost/websocket&quot; ) Usage of callbacks defmodule MyWebsocket do use Shogun.Websocket @impl Shogun.Websocket def on_connect ( _headers , state ) do # Doing something awesome ... state end end Opts url: url to websocket server (ws or wss), for instance ws://websocket_server/ . required connect_timeout: Connection timeout. default :infinity cookie_store: The cookie store that Gun will use for this connection. When configured, Gun will query the store for cookies and include them in the request headers; and add cookies found in response headers to the store. By default no cookie store will be used. domain_lookup_timeout: Domain lookup timeout. default :infinity http_opts: Options specific to the HTTP protocol. retry: Number of times Gun will try to reconnect on failure before giving up. retry_fun: A fun that will be called before every reconnect attempt. It receives the current number of retries left and the Gun options. It returns the next number of retries left and the timeout to apply before reconnecting. The default fun will remove one to the number of retries and set the timeout to the retry_timeout value. The fun must be defined as follow: fn ( non_neg_integer ( ) , opts ( ) ) -&gt; %{ retries =&gt; non_neg_integer ( ) , timeout =&gt; pos_integer ( ) } end The fun will never be called when the retry option is set to 0. When this function returns 0 in the retries value, Gun will do one last reconnect attempt before giving up. retry_timeout: Time between retries in milliseconds. default 5000 supervise: Whether the Gun process should be started under the gun_sup supervisor. Set to false to use your own supervisor. default true tcp_opts: TCP options used when establishing the connection. By default Gun enables send timeouts with the options [{send_timeout, 15000}, {send_timeout_close, true}]. tls_handshake_timeout: TLS handshake timeout. default :infinity tls_opts: TLS options used for the TLS handshake after the connection has been established, when the transport is set to tls. default [] trace: Whether to enable dbg tracing of the connection process. Should only be used during debugging. default false transport: Whether to use TLS or plain TCP. The default varies depending on the port used. Port 443 defaults to tls. All other ports default to tcp. ws_opts: Options specific to the Websocket protocol. Please visit https://ninenines.eu/docs/en/gun/2.0/manual/gun/ for more info about the opts","ref":"Shogun.Websocket.html","title":"Shogun.Websocket","type":"behaviour"},{"doc":"trigger when the websocket client fails to connect successfully","ref":"Shogun.Websocket.html#c:on_close/2","title":"Shogun.Websocket.on_close/2","type":"callback"},{"doc":"trigger when the websocket client connects successfully","ref":"Shogun.Websocket.html#c:on_connect/2","title":"Shogun.Websocket.on_connect/2","type":"callback"},{"doc":"trigger when the connection is lost (gun will try to connect again and upgrade to ws)","ref":"Shogun.Websocket.html#c:on_disconnect/2","title":"Shogun.Websocket.on_disconnect/2","type":"callback"},{"doc":"trigger when the websocket client has abruptly an error","ref":"Shogun.Websocket.html#c:on_error/2","title":"Shogun.Websocket.on_error/2","type":"callback"},{"doc":"trigger when the websocket client recieves an message from the server","ref":"Shogun.Websocket.html#c:on_message/2","title":"Shogun.Websocket.on_message/2","type":"callback"},{"doc":"","ref":"Shogun.Websocket.html#t:code/0","title":"Shogun.Websocket.code/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.html#t:headers/0","title":"Shogun.Websocket.headers/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.html#t:message/0","title":"Shogun.Websocket.message/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.html#t:reason/0","title":"Shogun.Websocket.reason/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.html#t:state/0","title":"Shogun.Websocket.state/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.Client.html","title":"Shogun.Websocket.Client","type":"behaviour"},{"doc":"Only intented to be used inside the websocket.ex file after init","ref":"Shogun.Websocket.Client.html#c:connect/1","title":"Shogun.Websocket.Client.connect/1","type":"callback"},{"doc":"","ref":"Shogun.Websocket.Client.html#t:state/0","title":"Shogun.Websocket.Client.state/0","type":"type"},{"doc":"","ref":"Shogun.Websocket.Gun.html","title":"Shogun.Websocket.Gun","type":"module"},{"doc":"GunTest can help to test your implementation of Shogun.Websocket Follow the steps to test it out First step: set the client for the websocket in config/test.exs config :shogun , Shogun.Websocket , client : Shogun.Websocket.GunTest Second step: now on your test, you can control the messages that your websocket received. defmodule MyApp.WebsocketTest do use ExUnit.Case , async : true alias Shogun.Websocket.GunTest setup _context do { :ok , ws_pid } = start_supervised ( { MyApp.Websocket , url : &quot;test&quot; } ) [ ws_pid : ws_pid ] end test &quot;validate message test is received by the client&quot; , %{ ws_pid : ws_pid } do GunTest . receive_message ( ws_pid , &quot;test&quot; ) assert :sys . get_state ( ws_pid ) . internal_state . message == &quot;test&quot; end end","ref":"Shogun.Websocket.GunTest.html","title":"Shogun.Websocket.GunTest","type":"module"},{"doc":"","ref":"Shogun.Websocket.GunTest.html#receive_message/2","title":"Shogun.Websocket.GunTest.receive_message/2","type":"function"}]